import { CdkConnectedOverlay, CdkOverlayOrigin } from '@angular/cdk/overlay';
import { AfterViewInit, ChangeDetectorRef, ElementRef, EventEmitter, OnDestroy, OnInit, TemplateRef } from '@angular/core';
import { Subject, Subscription } from 'rxjs';
import { AtGlobalMonitorService } from '../at-global-monitor.service';
import { OnClickCallback } from './at-modal.service';
export interface ClickPosition {
    x: number;
    y: number;
}
export declare class ModalComponent implements OnInit, AfterViewInit, OnDestroy {
    private el;
    private global_monitor;
    private cdr;
    constructor(el: ElementRef, global_monitor: AtGlobalMonitorService, cdr: ChangeDetectorRef);
    ngOnDestroy(): void;
    ngOnInit(): void;
    state: string;
    icon_status: {
        'info': string;
        'error': string;
        'warning': string;
        'success': string;
        'loading': string;
    };
    readonly onOk: EventEmitter<{}>;
    readonly onCancel: EventEmitter<{}>;
    showFooter: boolean;
    width: number;
    top: number;
    maskClose: boolean;
    showHeader: boolean;
    status: 'error' | 'success' | 'warning' | 'info';
    title: string | TemplateRef<void>;
    closeable: boolean;
    message: string | TemplateRef<void>;
    atType: 'confirm' | 'normal';
    atComponent: TemplateRef<void>;
    transformOrigin: string;
    cdkOverlay: CdkConnectedOverlay;
    modal: ElementRef;
    atOnClose: OnClickCallback<ModalComponent>;
    atOnOk: OnClickCallback<ModalComponent>;
    atAfterOk: () => void;
    startAnimation(): void;
    doneAnimation(): void;
    $showSubscription: Subscription;
    atAfterClose: () => void;
    ok(): void;
    cancel(): void;
    cancelInside(): void;
    okInside(): void;
    overlay: CdkOverlayOrigin;
    readonly showChange: EventEmitter<boolean>;
    private _show;
    $showChange: Subject<{}>;
    clickHide(event: MouseEvent): void;
    show: boolean;
    setShow(value: boolean): void;
    ngAfterViewInit(): void;
    private updateTransformOrigin;
    subscribeStatus(): void;
    isNonEmptyString(value: {}): boolean;
    isTemplateRef(value: {}): boolean;
    isComponent(value: {}): boolean;
}
